<template>
  <div class="store-shipping-address-container">
    <vab-query-form>
      <vab-query-form-left-panel :span="4">
        <el-button icon="el-icon-plus" type="primary" @click="handleEdit">
          {{ __('添加') }}
        </el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel :span="20">
        <el-button icon="el-icon-refresh" type="primary" @click="queryData">
          {{ __('刷新') }}
        </el-button>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table
      v-loading="listLoading"
      border
      :data="list"
      :height="tableConfig.height"
    >
      <el-table-column align="center" fixed :label="__('操作')" width="120">
        <template #default="{ row }">
          <el-button type="text" @click="handleEdit(row)">
            {{ __('编辑') }}
          </el-button>
          <el-button type="text" @click="handleDelete(row)">
            {{ __('删除') }}
          </el-button>
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        :label="__('编号')"
        prop="ss_id"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('邮编')"
        prop="ss_postalcode"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('手机号码')"
        prop="ss_mobile"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('联系人')"
        prop="ss_name"
        show-overflow-tooltip
      />
      <el-table-column
        v-if="false"
        align="center"
        :label="__('联系IM')"
        prop="ss_postalcode"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('省份')"
        prop="ss_province"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('市')"
        prop="ss_city"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('县区')"
        prop="ss_county"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('详细地址')"
        prop="ss_address"
        show-overflow-tooltip
      />

      <el-table-column
        align="center"
        :label="__('是否默认')"
        prop="ss_is_default"
      >
        <template slot-scope="scope">
          <el-switch
            v-model="scope.row.ss_is_default"

            :active-value="1"

            :inactive-value="0"
            @change="sChange(scope.row)"
          />
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      background
      :current-page="queryForm.pageNum"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
    <edit ref="edit" @fetch-data="fetchData" />
  </div>
</template>

<script>
  import { translateTitle as __ } from '@/utils/i18n'

  import { del, edit, list } from '@/api/store/shipping/address'
  import Edit from './components/StoreShippingAddressEdit'

  export default {
    name: 'StoreShippingAddress',
    components: { Edit },
    data() {
      return {
        tableConfig: {
          height: window.innerHeight - 220 - 90,
        },
        list: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        queryForm: {
          pageNum: 1,
          pageSize: 20,
        },
      }
    },
    created() {
      this.fetchData()
    },
    methods: {
      formatDefault(row) {
        let ssIsDefault = row.ss_is_default
        return ssIsDefault === 1 ? '是' : '否'
      },
      __,
      handleEdit(row) {
        if (row.ss_id) {
          this.$refs['edit'].showEdit(row)
        } else {
          this.$refs['edit'].showEdit()
        }
      },
      handleDelete(row) {
        if (row.ss_id) {
          this.$baseConfirm(this.__('你确定要删除当前项吗'), null, async () => {
            const { msg, status } = await del({ ss_id: row.ss_id })
            if (200 == status) {
              this.$baseMessage(msg, 'success')
            } else {
              this.$baseMessage(msg, 'error')
            }
            await this.fetchData()
          })
        }
      },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNum = val
        this.fetchData()
      },
      queryData() {
        this.queryForm.pageNum = 1
        this.fetchData()
      },
      async sChange(row) {
        const param = {
          ss_id: row.ss_id,
          ss_is_default: row.ss_is_default,
        }
        const { msg, status } = await edit(param)
        this.$baseMessage(msg, 'success', false, 'vab-hey-message-success')
        this.fetchData()
      },
      async fetchData() {
        this.listLoading = true
        const { data } = await list(this.queryForm)
        this.list = data.items
        this.total = data.records
        this.listLoading = false
      },
    },
  }
</script>
